"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rsa = require("node-rsa");
require("isomorphic-fetch");
var btb = require("blob-to-buffer");
var SecureFile = /** @class */ (function () {
    function SecureFile(server, username, private_key) {
        this.Server = server;
        if (this.Server.endsWith("/")) {
            this.Server += "api";
        }
        else {
            this.Server += "/api";
        }
        this.Username = username;
        this.PrivateKey = private_key;
    }
    SecureFile.prototype.getCode = function () {
        return __awaiter(this, void 0, void 0, function () {
            var myHeaders, myInit, code_res, code, r;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        myHeaders = new Headers();
                        myHeaders.append('pragma', 'no-cache');
                        myHeaders.append('cache-control', 'no-cache');
                        myInit = {
                            method: 'GET',
                            headers: myHeaders,
                        };
                        return [4 /*yield*/, fetch(this.Server + "/code?username=" + this.Username, myInit)];
                    case 1:
                        code_res = _a.sent();
                        statusParser(code_res);
                        return [4 /*yield*/, code_res.json()];
                    case 2:
                        code = (_a.sent()).code;
                        r = new rsa(this.PrivateKey, "pkcs1-pem");
                        return [2 /*return*/, { code: code, signature: r.sign(code).toString("base64") }];
                }
            });
        });
    };
    SecureFile.prototype.makeRequest = function (endpoint, method, query, body) {
        return __awaiter(this, void 0, void 0, function () {
            var code, query_str, first, key, myHeaders;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getCode()];
                    case 1:
                        code = _a.sent();
                        query.code = code.code;
                        query.signature = code.signature;
                        query_str = "?";
                        first = true;
                        for (key in query) {
                            if (!first)
                                query_str += "&";
                            query_str += encodeURIComponent(key) + "=" + encodeURIComponent(query[key]);
                            first = false;
                        }
                        myHeaders = new Headers();
                        myHeaders.append('pragma', 'no-cache');
                        myHeaders.append('cache-control', 'no-cache');
                        return [4 /*yield*/, fetch(this.Server + endpoint + query_str, { method: method, body: body, headers: myHeaders })];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    SecureFile.prototype.test = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.makeRequest("/test", "GET", {}, undefined)];
                    case 1:
                        res = _a.sent();
                        statusParser(res);
                        return [4 /*yield*/, res.json()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    SecureFile.prototype.list = function (folder) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!folder)
                            folder = "root";
                        return [4 /*yield*/, this.makeRequest("/files", "GET", { folder: folder }, undefined)];
                    case 1:
                        res = _a.sent();
                        statusParser(res);
                        return [4 /*yield*/, res.json()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    SecureFile.prototype.create = function (name, data, type, folder, encrypt, preview) {
        if (encrypt === void 0) { encrypt = true; }
        return __awaiter(this, void 0, void 0, function () {
            var params, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = { type: type, name: name, no_encryption: !encrypt };
                        if (preview) {
                            params.preview = preview;
                        }
                        if (folder) {
                            params.folder = folder;
                        }
                        if (!encrypt) {
                            params.no_encryption = true;
                        }
                        return [4 /*yield*/, this.makeRequest("/files", "POST", params, data)];
                    case 1:
                        res = _a.sent();
                        statusParser(res);
                        return [2 /*return*/, res.json()];
                }
            });
        });
    };
    SecureFile.prototype.get = function (id, version) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(typeof version === "string")) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.makeRequest("/files/" + id + "/history/" + version, "GET", {}, undefined)];
                    case 1:
                        res = _a.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.makeRequest("/files/" + id, "GET", {}, undefined)];
                    case 3:
                        res = _a.sent();
                        _a.label = 4;
                    case 4:
                        statusParser(res);
                        if (res.buffer) {
                            return [2 /*return*/, res.buffer()];
                        }
                        else {
                            return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                                    var _a;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                _a = btb;
                                                return [4 /*yield*/, res.blob()];
                                            case 1:
                                                _a.apply(void 0, [_b.sent(), function (err, buffer) {
                                                        if (err)
                                                            reject(err);
                                                        else
                                                            resolve(buffer);
                                                    }]);
                                                return [2 /*return*/];
                                        }
                                    });
                                }); })];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    SecureFile.prototype.update = function (id, data, preview) {
        return __awaiter(this, void 0, void 0, function () {
            var put, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        put = {};
                        if (preview)
                            put.preview = preview;
                        return [4 /*yield*/, this.makeRequest("/files/" + id, "PUT", put, data)];
                    case 1:
                        res = _a.sent();
                        statusParser(res);
                        return [2 /*return*/, res.json()];
                }
            });
        });
    };
    SecureFile.prototype.delete = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.makeRequest("/files/" + id, "DELETE", {}, undefined)];
                    case 1:
                        res = _a.sent();
                        statusParser(res);
                        return [2 /*return*/, res.json()];
                }
            });
        });
    };
    SecureFile.prototype.history = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.makeRequest("/files/" + id + "/history", "GET", {}, undefined)];
                    case 1:
                        res = _a.sent();
                        statusParser(res);
                        return [2 /*return*/, res.json()];
                }
            });
        });
    };
    return SecureFile;
}());
exports.default = SecureFile;
var Unauthorized = /** @class */ (function (_super) {
    __extends(Unauthorized, _super);
    function Unauthorized() {
        return _super.call(this, "Not authorized") || this;
    }
    return Unauthorized;
}(Error));
exports.Unauthorized = Unauthorized;
var NotFound = /** @class */ (function (_super) {
    __extends(NotFound, _super);
    function NotFound() {
        return _super.call(this, "Not found") || this;
    }
    return NotFound;
}(Error));
exports.NotFound = NotFound;
var BadRequest = /** @class */ (function (_super) {
    __extends(BadRequest, _super);
    function BadRequest() {
        return _super.call(this, "Bad request") || this;
    }
    return BadRequest;
}(Error));
exports.BadRequest = BadRequest;
function statusParser(res) {
    if (res.status !== 200) {
        switch (res.status) {
            case 400:
                throw new BadRequest();
            case 404:
                throw new NotFound();
            case 403:
                throw new Unauthorized();
            default:
                throw new Error(res.statusText);
        }
    }
}
